// Copyright 2005 Alco Blom
// All rights reserved

var hexChars = "0123456789abcdef";

function isUnicode(sms)
{    
	var unicode;
	
    if (canBeConvertedToGSM7bitEncoding(sms)) {
        unicode = false;
    } else {
        unicode = true;
    }
    
    return unicode;
}

function escapeSMS(sms)
{
	var txt;
	
    if (canBeConvertedToGSM7bitEncoding(sms)) {
		txt = createStringByAddingPercentEscapes(sms);
    } else {
        txt = createStringByUnicode(sms);
    }
    
    return txt;
}

function gsmLength(txt)
{
	var sms = txt;
	var nEuros = 0;
    var len = sms.length;
        
	// there is a bug in replace regarding Euro...

    // how many Euro characters are there?
	for(var i=0;i<len;i++) {
		value = sms.charCodeAt(i);
		if (value == 8364)
			nEuros += 1;
	}
	
	// how many characters from the extension table?
	sms = sms.replace(/[\x5b\x5c\x5d\x5e\x7b\x7c\x7d\x7e]/g, "22");
	len = sms.length + nEuros;
	
	// log("GSM Length is: " + len);
	
	return len;
}

function canBeConvertedToGSM7bitEncoding(sms)
{
    var uc;
    var gsm7bit = true;       
    var len = sms.length;
        
	for(var i = 0;i < len;i++) {
        
        uc = sms.charCodeAt([i]);
        
        if (uc == 10 || uc == 13) // LF and CR
        
            gsm7bit = true;
            
        else if (uc >= 20 && uc <= 95)
        
            gsm7bit = true;
            
        else if (uc >= 97 && uc <= 126)
        
            gsm7bit = true;
            
        else {
            switch(uc) {
                case 8364: // Euro currency
                    gsm7bit = true;
                    break;
                    
                case 160:  // NBSP
                case 161:  // ¡ = inverted exclamation mark
                case 163:  // £
                case 164:  // currency sign
                case 165:  // ¥ = Yen sign
                case 167:  // § = section sign
                case 191:  // ¿ = inverted question mark
                case 196:  // Ä
                case 214:  // Ö
                case 209:  // Ñ
                case 220:  // Ü
                case 228:  // ä
                case 246:  // ö
                case 241:  // ñ
                case 252:  // ü
                case 224:  // à
                case 232:  // è
                case 233:  // é
                case 249:  // ù
                case 236:  // ì
                case 242:  // ò
                case 199:  // Ç
                case 216:  // Ø
                case 248:  // ø
                case 8491: // A %Aring;
                case 229:  // a &aring;
                
                case 197:  // A %Aring;
                case 198:  // capital letter AE
                case 230:  // small letter ae
                case 223:  // ß
                case 201:  // É

                case 916:  // greek capital delta
                case 8710:
                
                case 934:  // greek capital phi
                case 966:
                
                case 915:  // greek capital gamma
                
                case 923:  // greek capital lambda
                
                case 937:  // greek capital omega
                case 8486:
                
                case 928:  // greek capital pi
                case 982:
                case 8719:
                
                case 936:  // greek capital psi
                
                case 931:  // greek capital sigma
                case 8721:
                
                case 920:  // greek capital theta
                case 1012:
                
                case 926:  // greek capital xi
                    gsm7bit = true;
                    break;
                
                default:
                    gsm7bit = false;
                    break;
            }
        }
                
        // as soon as Unicode detected, return false
        if (gsm7bit == false)
            break;
    }
        
    return gsm7bit;
}

function createStringByAddingPercentEscapes(sms)
{
    var uc;
    var msg = "";
    var len = sms.length;
        
	for(var i = 0;i < len;i++) {
        
        uc = sms.charCodeAt([i]);
        
        if (uc >= 32 && uc <= 47)
        
            msg += escape(sms.charAt([i])); // escape
            
        else if (uc >= 48 && uc <= 57) // 0..9
        
            msg += sms.charAt([i]);
            
        else if (uc >= 58 && uc <= 64) // :;<=>?@
        
            msg += escape(sms.charAt([i])); // escape
            
        else if (uc >= 65 && uc <= 90) // A..Z
        
            msg += sms.charAt([i]);

        else if (uc >= 91 && uc < 96) // [\]^_
                
            msg += escape(sms.charAt([i])); // escape
            
        else if (uc >= 97 && uc <= 122) { // a..z
        
            msg += sms.charAt([i]);
			
        } else if (uc >= 123 && uc <= 126) // {|}~
                
            msg += escape(sms.charAt([i])); // escape
            
        else {
            switch(uc) {
                case 10: // line feed
                    msg += "%0a";
                    break;
                    
                case 12: // form feed
                    msg += "%0a"; // keuze
                    break;
                    
                case 13: // carriage return
                    msg += "%0d";
                    break;
                    
                case 8364: // Euro currency
                    msg += "%80";
                    break;
                    
                case 160: // NBSP
                    msg += "%20";
                    break;
                    
                case 161: // ¡ = inverted exclamation mark
                    msg += "%a1";
                    break;
            
                case 163: // £
                    msg += "%a3";
                    break;
                    
                case 164: // currency sign
                    msg += "%24";
                    break;
                    
                case 165: // ¥
                    msg += "%a5";
                    break;
                
                case 167: // §
                    msg += "%a7";
                    break;
                    
                case 191: // ¿ = inverted question mark
                    msg += "%bf";
                    break;
                    
                case 196: // Ä
                    msg += "%c4";
                    break;
            
                case 214: // Ö
                    msg += "%d6";
                    break;
            
                case 209: // Ñ
                    msg += "%d1";
                    break;
                    
                case 220: // Ü
                    msg += "%dc";
                    break;
                
                case 228: // ä
                    msg += "%e4";
                    break;
                    
                case 246: // ö
                    msg += "%f6";
                    break;

                case 241: // ñ
                    msg += "%f1";
                    break;

                case 252: // ü
                    msg += "%fc";
                    break;
                    
                case 224: // à
                    msg += "%e0";
                    break;

                case 232: // è
                    msg += "%e8";
                    break;

                case 233: // é
                    msg += "%e9";
                    break;
                
                case 249: // ù
                    msg += "%f9";
                    break;

                case 236: // ì
                    msg += "%ec";
                    break;

                case 242: // ò
                    msg += "%f2";
                    break;

                case 199: // Ç
                    msg += "%c7";
                    break;

                case 216: // Ø
                    msg += "%d8";
                    break;
                    
                case 248: // ø
                    msg += "%f8";
                    break;
                    
                case 8491: // A
                    msg += "%c5";
                    break;
                    
                case 229: // a
                    msg += "%e5";
                    break;
                                    
                case 198: // capital letter AE
                    msg += "%c6";
                    break;
                    
                case 230: // small letter ae
                    msg += "%e6";
                    break;
                    
                case 223: // ß
                    msg += "%df";
                    break;
                    
                case 201: // É
                    msg += "%c9";
                    break;
                    
                case 916: // greek capital delta
                case 8710:
                    msg += "%10";
                    break;
                                    
                case 934:  // greek capital phi
                case 966:
                    msg += "%12";
                    break;
                                    
                case 915:  // greek capital gamma
                    msg += "%13";
                    break;
                
                case 923:  // greek capital lambda
                    msg += "%14";
                    break;
                
                case 937:  // greek capital omega
                case 8486:
                    msg += "%15";
                    break;
                
                case 928: // greek capital pi
                case 982:
                case 8719:
                    msg += "%16";
                    break;
                
                case 936:  // greek capital psi
                    msg += "%17";
                    break;
                    
                case 931: // greek capital sigma
                case 8721:
                    msg += "%18";
                    break;
                
                case 920:  // greek capital theta
                case 1012:
                    msg += "%19";
                    break;
                    
                case 926:  // greek capital xi
                    msg += "%1a";
                    break;
                
                default:
                    break;
            }
        }
    }
    
    return msg;
}

function createStringByUnicode(sms)
{
    var uc;
    var msg = "";
    var len = sms.length;
        
	for(var i = 0;i < len;i++) {
        
        uc = sms.charCodeAt([i]);
        if (uc < 256) {
        	msg += "00";
        	msg += dec2hex(uc);
        } else {
			var lower = uc % 256;
			var upper = (uc - lower) / 256;
			
			msg += dec2hex(upper);
			msg += dec2hex(lower);
        }
    }
    
    return msg;
}

function dec2hex(dec)
{
	var i = dec % 16;
	var j = (dec - i) / 16;
	return hexChars.charAt(j) + hexChars.charAt(i);
}
